;*****************************************************************************
;*                                                                           *
;* RGB frame                                                                 *
;* Copyright (C) 2020 by Walter Lain <kcswalter@member.fsf.org>              *
;*                                                                           *
;* This program is free software; you can redistribute it and/or modify      *
;* it under the terms of the GNU General Public License as published by      *
;* the Free Software Foundation; either version 3 of the License, or         *
;* (at your option) any later version.                                       *
;*                                                                           *
;* This program is distributed in the hope that it will be useful,           *
;* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
;* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
;* GNU General Public License for more details.                              *
;*                                                                           *
;* You should have received a copy of the GNU General Public License         *
;* along with this program; if not, write to the Free Software               *
;* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
;*                                                                           *
;*****************************************************************************

; ________________________________________________
; |         Timer control for RGB frame          |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Type      : ASM                            |
; |   Version   : 1                              |
; |   Release   : 0                              |
; |   Author    : Lain Walter                    |
; |   Date      : 10/01/21                       |
; |______________________________________________|

;_______________________________________________________Timer init
;Initialize timers
;Modified registers:
;	system
;	b_TMR3_CNT
;	b_TMR4_CNT
;Call method
;	CALL Timer_Init
Timer_Init:
	BANKSEL T0CON0			;Bank 11
	MOVLF c_TMR0_CON0,T0CON0	;Set Timer0
	MOVLF c_TMR0_CON1,T0CON1	;
	BANKSEL T1CON			;Bank 4
	BCF T1CON,TMR1ON		;Disable Timer1
	MOVLF c_TMR1_CON,T1CON		;Set Timer1
	MOVLF c_TMR1_GCON,T1GCON	;
	MOVLF c_TMR1_GATE,T1GATE	;
	MOVLF c_TMR1_CLK,T1CLK		;
	MOVLF c_TMR1_TIME_H,TMR1H	;Set timer1 duration
	MOVFF c_TMR1_TIME_L,TMR1L	;
	BANKSEL T2CON			;Bank 5
	MOVLF c_TMR2_CON,T2CON		;Set Timer2
	MOVLF c_TMR2_CLK,T2CLKCON	;
	MOVLF c_TMR2_HLT,T2HLT		;
	MOVLF c_TMR2_RST,T2RST		;
	BANKSEL PIR0			;Bank 14
	BCF PIR0,TMR0IF			;Clear Timer0 IRQ flag
	BCF PIE0,TMR0IE			;Disable Timer0 IRQ
	BCF PIR4,TMR1IF			;Clear Timer1 IRQ flag
	BSF PIE4,TMR1IE			;Enable Timer1 IRQ
	BCF PIR4,TMR2IF			;Clear Timer2 IRQ flag
	BCF PIE4,TMR2IE			;Disable Timer2 IRQ
	BANKSEL b_TMR3_CNT		;Bank 0
	MOVLF c_TMR3_DIV,b_TMR3_CNT	;Load Timer3
	MOVLF c_TMR4_DIV,b_TMR4_CNT	;Load Timer4
	RETURN
